{*************************************}
{* Private variables for interface    }
{*************************************}

{ For GENERAL variables               }

VAR
    Bhh,Bll  :Byte                    ;
    Error    :word                    ;
    S        :String                  ;
    X,T      :word                    ;
    BXX      :word                    ;
    C        :Char                    ;

    SaveI    :Pointer                 ;

    SaveIM1  :Word                    ;
    SaveIM2  :Word                    ;
    I        :Word                    ;
    Success  :boolean                 ;
    IRQ      :word                    ;
    Dummy    :word                    ;
    D,DMA    :word                    ;
    DMA_A    :byte                    ;
    DMA_B    :byte                    ;


CONST Err    :boolean=False;

{ ++ MIDI variables                   }

VAR

    MIDIBuf  :Array[1..2050]of longint;
    MIDICount:Integer                 ;
    MIDItimer:Longint                 ;
    MB       :Byte                    ;

    Midi_in_mask1  :byte              ;
    Midi_in_mask2  :byte              ;
    Midi_in_addr   :pointer           ;
    Midi_Timer_Save:Procedure         ;

    Midi_code      :longint           ;

{ ++ DIG. voice variables             }

VAR

   Time_Constant   : Word             ;
   Data_Length     : Word             ;
   Page            : Byte             ;
   A,B             : Byte             ;

{ ++ FM voice variables               }

{ INTERNAL instrument table for FM's PROGRAM command}
CONST
  inst : array[1..16] of array[1..16] of byte =
                ( ( $21,$11,$4c,$00,$f1,$f2,$63,$72,
                    $00,$00,$04,$00,$00,$00,$00,$00 ),

                  ( $a5,$b1,$d2,$80,$81,$f1,$03,$05,
                    $00,$00,$02,$00,$00,$00,$00,$00 ),

                  ( $71,$62,$1c,$05,$51,$52,$03,$13,
                    $00,$00,$0e,$00,$00,$00,$00,$00 ),

                  ( $11,$01,$8a,$40,$f1,$f1,$11,$b3,
                    $00,$00,$06,$00,$00,$00,$00,$00 ),

                  ( $21,$11,$11,$00,$a3,$c4,$43,$22,
                    $02,$00,$0d,$00,$00,$00,$00,$00 ),

                  ( $31,$a1,$1c,$80,$41,$92,$0b,$3b,
                    $00,$00,$0e,$00,$00,$00,$00,$00 ),

                  ( $71,$62,$c5,$05,$6e,$8b,$17,$0e,
                    $00,$00,$02,$00,$00,$00,$00,$00 ),

                  ( $41,$91,$83,$00,$65,$32,$05,$74,
                    $00,$00,$0a,$00,$00,$00,$00,$00 ),

                  ( $01,$13,$8d,$00,$51,$52,$53,$7c,
                    $01,$00,$0c,$00,$00,$00,$00,$00 ),

                  ( $32,$16,$87,$80,$a1,$7d,$10,$33,
                    $00,$00,$02,$00,$00,$00,$00,$00 ),

                  ( $32,$35,$87,$80,$a1,$7d,$10,$33,
                    $00,$00,$08,$00,$00,$00,$00,$00 ),

                  ( $42,$16,$87,$20,$a1,$7d,$10,$33,
                    $00,$00,$08,$00,$00,$00,$00,$00 ),

                  ( $32,$16,$11,$80,$a1,$7d,$10,$33,
                    $00,$f0,$08,$00,$00,$00,$00,$00 ),

                  ( $21,$41,$87,$80,$a1,$7d,$10,$33,
                    $00,$00,$08,$00,$00,$00,$00,$00 ),

                  ( $32,$16,$37,$80,$a1,$7d,$10,$33,
                    $00,$00,$08,$00,$00,$00,$00,$00 ),

                  ( $30,$16,$87,$80,$23,$22,$10,$33,
                    $00,$00,$08,$00,$00,$00,$00,$00 ));

CONST   Fmbyte     :array[1..9]  of byte=(0,0,0,0,0,0,0,0,0);
CONST   FM_TUNE    :array[1..16] of byte=(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16);
CONST   CELLMODOFS :Array[1..9]  of byte=($00,$01,$02,$08,$09,$0A,$10,$11,$12);
CONST   CELLCAROFS :Array[1..9]  of byte=($03,$04,$05,$0B,$0C,$0D,$13,$14,$15);
CONST   Instruments:Pointer=@inst;
CONST   Int_inst   :Boolean=True ;
CONST   PLAYING    :Array[1..9]  of byte=(0,0,0,0,0,0,0,0,0);
CONST   Transpose  :Integer=0           ;
CONST   Maxch      :byte=9              ;
CONST   LastFMCh   :Byte=0              ;
CONST   Stereo     :Boolean=False       ;

VAR     FM_INST    :array[1..16] of array[1..16] of byte;
        CH_NOTE    :Array[1..16] of byte;
        FM_PLAYS   :Array[1..9]  of byte;
        Free_ch    :byte                ;

        Pan_left   :Array[1..16] of byte; { muting value }
        Pan_right  :Array[1..16] of byte; { muting value }
        Leftvol,
        Rightvol   :byte                ;

        Lowbyte    :byte                ;
        Highbyte   :byte                ;

